;************************************************
;LEKCJA   6	- WYWIETLACZ 7-SEGMENTOWY
;PRZYKAD 3	- PRZEGLDANIE WYWIETLACZA
;************************************************

SEG_ON EQU	P1.6	;wczenie wywietlacza 7-segm.

;Stae uywane w programie
ONE	EQU	006H		;kod cyfry 1
TWO	EQU	05BH		;kod cyfry 2
THREE	EQU	04FH		;kod cyfry 3
FOUR	EQU	066H		;kod cyfry 4
FIVE	EQU	06DH		;kod cyfry 5
SIX	EQU	07DH		;kod cyfry 6
SEVEN	EQU	007H		;kod cyfry 7

;Pami wewntrzna RAM
DISPLAY		EQU	30H

;**************************************
	LJMP	START
	ORG	100H
START:

	MOV	DISPLAY,#ONE		;wpisz kody cyfr
	MOV	DISPLAY+1,#TWO		;dla kolejnych
	MOV	DISPLAY+2,#THREE	;wskanikw
	MOV	DISPLAY+3,#FOUR
	MOV	DISPLAY+4,#FIVE
	MOV	DISPLAY+5,#SIX
	MOV	DISPLAY+6,#SEVEN

LOOP_DISP:			;ustawienie danych do
				;wywietlania na 1-szym
				;wskaniku
	MOV	R0,#DISPLAY	  ;adres pobierania kodw
	MOV	R2,#7		  ;licznik-il. wskanikw
	MOV	R3,#00000001B ;wybr wskanika
				  ;-kod 1 z 8

LOOP:
	SETB	SEG_ON		;wycz poprzedni
				;wskanik

	MOV	R1,#CSDS	;adres wyboru wskanika
	MOV	A,R3		;aktualny wskanik (1z8)
	MOVX	@R1,A		;wpisz nr wskanika

	RL	A		;obrt w lewo - numer
	MOV	R3,A		;nastpnego wskanika
				;(kod 1 z 8)

	MOV	R1,#CSDB	;adres danych wskanika
	MOV	A,@R0		;kod aktualnego wskanika
	MOVX	@R1,A		;wpisz kod segmentw

	INC	R0		;adres pobierania kodu
				;dla nastpnego wskanika

	CLR	SEG_ON		;wczenie wskanika

	MOV	A,#1		;czas 1ms - wiecenie
	LCALL	DELAY_MS	;jednego wskanika

	DJNZ	R2,LOOP		;kolejne wiecenie
				;siedmiu wskanikw

	SJMP	LOOP_DISP	;zacznij od wskanika 1
