;************************************************
;LEKCJA   8	- KLAWIATURA MATRYCOWA
;PRZYKAD 3	- ODCZYT KLAWIATURY
;************************************************

	LJMP	START
	ORG	100H
START:

	LCALL	LCD_CLR

LOOP_NO:
	MOV	R0,#CSKB0	;adres klawiszy 0..7
	MOVX	A,@R0		;odczyt stanu klawiszy
	CPL	A
	JNZ	KEY_YES		;czy klawisz nacinity
	INC	R0		;adres klawiszy 8..
	MOVX	A,@R0
	CPL	A
	JZ	LOOP_NO		;czy klawisz nacinity

KEY_YES:			;eliminacja drga stykw
	MOV	R2,A		;zapamitaj stan klawiszy
	MOV	A,#10
	LCALL	DELAY_MS
	MOVX	A,@R0		;odczyt stanu klawiszy
	CPL	A
	XRL	A,R2		;porwnaj z zapamitanym
	JNZ	LOOP_NO		;czy stan stabilny
				;-klawisz nadal wcinity

	MOV	A,R2		;stan klawiszy do A
			;ustaw wstpn warto R2
			;zalenie od zestawu klawiszy
	MOV	R2,#07H		;klawisze 8..
	CJNE	R0,#CSKB0,LOOP_NR
	MOV	R2,#0FFH	;klawisze 0..7

LOOP_NR:			;przekodowanie klawisza
	INC	R2		;kod 1z8 na numer 0..15
	RRC	A
	JNC	LOOP_NR

	MOV	A,R2		;przekodowanie klawisza
	ACALL	KEY_CODE	;na kody LCD za pomoc
				;procedury kodujcej
	LCALL	WRITE_DATA	;wypisz kod klawisza
	
LOOP_YES:
	MOV	R0,#CSKB0	;adres klawiszy 0..7
	MOVX	A,@R0		;odczyt stanu klawiszy
	CPL	A
	JNZ	LOOP_YES	;czy klawisz zwolniony
	INC	R0		;adres klawiszy 8..
	MOVX	A,@R0		;odczyt stanu klawiszy
	CPL	A
	JNZ	LOOP_YES	;czy klawisz zwolniony

	SJMP	LOOP_NO		;powrt do oczekiwania
				;na nacinicie klawisza

;**************************************
;Podprogram zamieniajcy numery klawiszy
;0..15 na kody znakw LCD

KEY_CODE:
	INC	A		;pomi rozkaz RET
	MOVC	A,@A+PC		;pobierz kod
	RET

	DB	30H,31H,32H		;0,1,2
	DB	33H,34H,35H		;3,4,5
	DB	36H,37H,38H		;6,7,8
	DB	39H,3CH,3EH		;9,<,>
	DB	5EH,76H,7FH		;^,v,Esc
	DB	0AEH			;Enter
