;************************************************
;LEKCJA  13	- STEROWNIK TRANSMISJI SZEREGOWEJ
;PRZYKAD 3	- OBSUGA W PRZERWANIU
;************************************************

;********* Ustawienie TIMERw *********
;TIMER 0
T0_G	EQU	0	;GATE
T0_C	EQU	0	;COUNTER/-TIMER
T0_M	EQU	0	;MODE (0..3)
TIM0	EQU	T0_M+T0_C*4+T0_G*8
;TIMER 1
T1_G	EQU	0	;GATE
T1_C	EQU	0	;COUNTER/-TIMER
T1_M	EQU	2	;MODE (0..3)
TIM1	EQU	T1_M+T1_C*4+T1_G*8

TMOD_SET	EQU	TIM0+TIM1*16

;******* Transmisja Szeregowa *********
TR_M	EQU	1	;tryb transmisji (1..3)
TR_R	EQU	1	;zezwolenie na odbir

SCON_SET	EQU	TR_M*64+TR_R*16

;SMOD=1
;TIMER1=57600/300bodw=192
TH1_SET		EQU	256-192
TL1_SET		EQU	256-192
;**************************************

	LJMP	START

;********* Przerwanie RS 232 **********
	ORG	23H
	PUSH	ACC
	PUSH	PSW
	JBC	TI,NAD		;koniec nadania znaku
	CLR	RI		;znak odebrany
	MOV	A,SBUF		;pobranie znaku
	LCALL	WRITE_DATA	;wywietl na LCD
NAD:
	POP	PSW
	POP	ACC
	RETI	

;**************************************
	ORG	100H
START:
	MOV	SCON,#SCON_SET		;port szeregowy
	ORL	PCON,#80H		;SMOD=1
	MOV	TMOD,#TMOD_SET		;Timer 1 dla
	MOV	TH1,#TH1_SET		;transmisji	
	MOV	TL1,#TL1_SET
	SETB	TR1			;start Timera 1

	SETB	EA		;zezwolenie na przerwanie
	SETB	ES		;z transmisji szeregowej

	LCALL	LCD_CLR
LOOP:
	LCALL	WAIT_KEY	;czekaj na klawisz
	ADD	A,#30H		;modyfikuj
	MOV	SBUF,A		;nadaj znak
	SJMP	LOOP
