;************************************************
;LEKCJA  17	- PRZETWARZANIE A/C I C/A
;PRZYKAD 3	- TESTER TRANZYSTORW
;************************************************

;********** Ustawienie 8255 ***********
;PORT A -> przetwornik C/A 4bit

PA_M	EQU	0	;TRYB 0..2
PA_D	EQU	0	;OUT->0, IN->1
PCA_D	EQU	0	;OUT->0, IN->1
PB_M	EQU	0	;TRYB 0..1
PB_D	EQU	0	;OUT->0, IN->1
PCB_D	EQU	0	;OUT->0, IN->1

PA	EQU	PA_M*4+PA_D*2+PCA_D
PB	EQU	PB_M*4+PB_D*2+PCB_D
SET_8255	EQU	80H+PA*8+PB

;**************************************
	LJMP	START
	ORG	100H
START:

	MOV	R0,#CS55D	;ustawienie ukadu 8255
	MOV	A,#SET_8255
	MOVX	@R0,A

	LCALL	LCD_CLR

	LCALL	WAIT_KEY	;numer klawisza jako prd
	MOV	R0,#CS55A	;bazy tranzystora
	MOVX	@R0,A

	PUSH	ACC		;wpisz prd bazy na LCD
	MOV	DPTR,#TEXT3
	LCALL	WRITE_TEXT
	POP	ACC
	LCALL	WRITE_HEX
	MOV	A,#8H+4H
	LCALL	WRITE_INSTR

	MOV	R0,#CSDA	;adres przetwornika C/A
	MOV	R1,#CSMX	;adres multipleksera
LOOP:
	LCALL	WAIT_KEY	;wybrany klawisz (0..15)
	MOV	R2,A
	MOV	A,#80H+40H	;LCD na pocztek drugiej
	LCALL	WRITE_INSTR	;linii
	MOV	A,R2		;powielenie numeru na
	SWAP	A		;cay bajt
	ADD	A,R2
	MOVX	@R0,A		;wpis do przetwornika C/A
	LCALL	WRITE_HEX	;i wpis na LCD wartoci
				;podawanej na wyjcie

	CLR	A		;podczenie wejcia 0
	MOVX	@R1,A		;do przetwornika A/C
	MOV	DPTR,#TEXT1
	LCALL	WRITE_TEXT
	DEC	R1		;inicjowanie pracy
	MOVX	@R1,A		;przetwornika A/C
	MOV	A,#1
	LCALL	DELAY_MS
	MOVX	A,@R1		;wynik pomiaru wejcia 0
	INC	R1
	LCALL	WRITE_HEX

	MOV	A,#1		;podczenie wejcia 1
	MOVX	@R1,A		;do przetwornika A/C
	MOV	DPTR,#TEXT2
	LCALL	WRITE_TEXT
	DEC	R1		;inicjowanie pracy
	MOVX	@R1,A		;przetwornika A/C
	MOV	A,#1
	LCALL	DELAY_MS
	MOVX	A,@R1		;wynik pomiaru wejcia 1
	INC	R1
	LCALL	WRITE_HEX

	SJMP	LOOP

TEXT1:
	DB	'-> N0=',0
TEXT2:
	DB	' N1=',0
TEXT3:
	DB	'Prad Bazy = ',0
