;************************************************
;LEKCJA   5	- STOS
;PRZYKAD 2	- PODPROGRAMY
;************************************************

	LJMP	START
	ORG	100H
START:

	LCALL	LCD_CLR

	MOV	A,#137			;do A liczba 137
	ACALL	WRITE_BCD_HEX		;wywoaj podprogram

	SJMP	$

;**************************************
;podprogram wypisuje liczb z akumulatora
;najpierw dziesitnie a nastpnie szesnastkowo
;podprogram nie zmienia zawartoci rejestrw

WRITE_BCD_HEX:
	PUSH	PSW		;przechowaj rejestry
	PUSH	B		;na stosie
	PUSH	ACC

	ACALL	BIN_BCD		;wywoaj podprogram
				;zamiany liczby binarnej
				;na liczb BCD

	XCH	A,B		;zamie A<->B
				;setki do A
				;dziesitki i jedn. do B
	LCALL	WRITE_HEX	;wywietl setki
	
	MOV	A,B		;dziesitki i jedn. do A
	LCALL	WRITE_HEX	;wywietl

	MOV	A,#'='
	LCALL	WRITE_DATA

	POP	ACC		;odtwrz liczb binarn
	PUSH	ACC		;-skopiuj ze stosu do A
				;czyli pobierz do A
				;i po A z powrotem
	LCALL	WRITE_HEX	;wywietl

	MOV	A,#'H'
	LCALL	WRITE_DATA	;dopisz H do liczby

	POP	ACC		;odtwrz rejestry
	POP	B
	POP	PSW

	RET			;powrt z podprogramu

;**************************************
;podprogram zamienia liczb binarn z A
;na liczb w kodzie upakowane BCD
;B - setki
;A - dsziesitki i jednostki

BIN_BCD:			
	MOV	B,#100		;wydziel setki
	DIV	AB		;dzielc przez 100
	PUSH	ACC		;przechowaj setki

	MOV	A,B		;wydziel dziesitki
	MOV	B,#10		;dzielc przez 10
	DIV	AB

	SWAP	A		;przesu dziesitki
	ORL	A,B		;dodaj jednostki
	POP	B		;odtwrz setki do B

	RET			;koniec podprogramu
