;************************************************
;LEKCJA   9	- WYWIETLACZ ALFANUMERYCZNY LCD
;PRZYKAD 3	- DEFINIOWANIE ZNAKU
;************************************************

	LJMP	START
	ORG	100H
START:

	MOV	R0,#LCDWC	;adres wpisu instrukcji
	MOV	R1,#LCDRC	;adres odczytu stanu

	MOV	A,#48H		;ustaw adres generatora
	LCALL	WRITE		;znakw dla znaku 1

	INC	R0		;adres wpisu danych
	MOV	DPTR,#LITERA ;adres definicji litery
	MOV	R3,#8		;licznik bajtw definicji

LOOP:				;wpisz definicj litery
				;do generatora znakw LCD
	CLR	A
	MOVC	A,@A+DPTR	;odczyt kolejnego bajtu
	LCALL	WRITE		;zapis do generatora zn.
	INC	DPTR		;modyfikacja adresu
	DJNZ	R3,LOOP		;przepisanie 8 bajtw

	DEC	R0		;adres wpisu instrukcji

	MOV	A,#1		;kasuj dane wywietlacza
	LCALL	WRITE

	MOV	A,#0FH		;wcz wywietlacz,kursor
	LCALL	WRITE		;i mruganie kursora

	MOV	A,#06H		;ustaw kierunek przesuwu
	LCALL	WRITE		;kursora

	INC	R0		;adres wpisu danych
	MOV	DPTR,#TEXT	;adres tekstu do
				;wywietlenia na LCD

WRITE_TXT:			;wpisz tekst na LCD
	CLR	A
	MOVC	A,@A+DPTR	;pobranie znaku tekstu
	JZ	TEXT_END	;bajt=0 - koniec tekstu
	LCALL	WRITE		;wpis na wywietlacz
	INC	DPTR		;modyfikacja adresu
	SJMP	WRITE_TXT	;wpisz kolejny znak

TEXT_END:
	SJMP	$		;koniec programu

;**************************************
;Podprogram wpisu danych lub instrukcji
;na wywietlacz LCD
;Zakada prawidowe adresy w R0 i R1

WRITE:
	MOV	R2,A		;przechowanie danych
BUSY:
	MOVX	A,@R1		;odczytanie stanu
	JB	ACC.7,BUSY	;oczekiwanie na BUSY=0
	MOV	A,R2		;odtworzenie danych
	MOVX	@R0,A		;wysanie danych
	RET

;**************************************
;Tabela bajtw definiujcych liter ''
LITERA:
	DB	00000010B
	DB	00000100B
	DB	00010110B
	DB	00011001B
	DB	00010001B
	DB	00010001B
	DB	00010001B
	DB	00000000B

;**************************************
TEXT:
	DB	'Gdansk  '
	DB	'Gda',1,'sk',0
