;************************************************
;LEKCJA  11	- TIMERY MIKROKONTROLERA
;PRZYKAD 2	- LICZNIK ZDARZE
;************************************************

SEG_ON EQU	P1.6	      ;wczenie wyw.7-segm.
KEY_COD EQU	01010101B	;wybrane klawisze-1,3,5

;********* Ustawienie TIMERw *********
;TIMER 0
T0_G	EQU	0	;GATE
T0_C	EQU	0	;COUNTER/-TIMER
T0_M	EQU	0	;MODE (0..3)
TIM0	EQU	T0_M+T0_C*4+T0_G*8
;TIMER 1
T1_G	EQU	0	;GATE
T1_C	EQU	1	;COUNTER/-TIMER
T1_M	EQU	0	;MODE (0..3)
TIM1	EQU	T1_M+T1_C*4+T1_G*8

TMOD_SET	EQU	TIM0+TIM1*16

TL1_SET		EQU	0	;warto pocztkowa
;**************************************

	LJMP	START
	ORG	100H
START:

	MOV	TMOD,#TMOD_SET		;Timer 1 licznik
	MOV	TL1,#TL1_SET
	SETB	TR1			;start Timera 1

	MOV	R0,#CSDS	;statyczna obsuga klaw.
	MOV	A,#KEY_COD	;i wywietlacza
	MOVX	@R0,A		;wpis wybranych klawiszy
				;i wskanikw

	MOV	R0,#CSDB	;adres danych wskanika
	CLR	SEG_ON		;wcz wywietlacz

LOOP:				;przepisanie zawartoci
	MOV	A,TL1		;licznika jako dane
	MOVX	@R0,A		;dla wywietlacza
	SJMP	LOOP
