;************************************************
;LEKCJA  11	- TIMERY MIKROKONTROLERA
;PRZYKAD 3	- TRYBY PRACY
;************************************************

LED	EQU	P1.7
KEY_COD EQU	00111111B     ;wszystkie klawisze

;********* Ustawienie TIMERw *********
;TIMER 0
T0_G	EQU	0	;GATE
T0_C	EQU	0	;COUNTER/-TIMER
T0_M	EQU	0	;MODE (0..3)
TIM0	EQU	T0_M+T0_C*4+T0_G*8
;TIMER 1
T1_G	EQU	0	;GATE
T1_C	EQU	1	;COUNTER/-TIMER
T1_M	EQU	0	;MODE (0..3)
TIM1	EQU	T1_M+T1_C*4+T1_G*8

TMOD_SET	EQU	TIM0+TIM1*16

TL1_SET		EQU	0	;warto pocztkowa
TH1_SET		EQU	0	;warto pocztkowa
;**************************************

	LJMP	START
	ORG	100H
START:
	MOV	TMOD,#TMOD_SET		;Timer 1 licznik
	MOV	TL1,#TL1_SET
	MOV	TH1,#TH1_SET
	SETB	TR1			;start Timera 1

	MOV	R0,#CSDS
	MOV	A,#KEY_COD
	MOVX	@R0,A			;wybrane klawisze

	SJMP	DISPLAY
LOOP:
	MOV	A,R2		;wpisz zawarto licznika
	CJNE	A,TL1,DISPLAY		;jeli jego warto
					;ulega zmianie
	SJMP	LOOP

DISPLAY:		;wpisanie zawartoci licznika
	LCALL	LCD_CLR		;na wywietlacz LCD
	MOV	R2,TL1		;zapamitaj modsz cz

	MOV	A,TH1		;wpisz starsz
	LCALL	WRITE_HEX
	MOV	A,R2		;i modsz cz licznika
	LCALL	WRITE_HEX

	JNB	TF1,LOOP
	CLR	TF1		;sygnalizuj przepenienie
	CPL	LED		;licznika

	SJMP	LOOP
